package com.izouma.awesomeadmin.web;

import java.util.*;

import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.HouseInfo;
import com.izouma.awesomeadmin.service.HouseInfoService;

/**
 * controller类
 */
@Controller
@RequestMapping("/houseInfo")
public class HouseInfoController extends BaseController {

    @Autowired
    private HouseInfoService houseInfoService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(HouseInfo record) {
        List<HouseInfo> pp = houseInfoService.getHouseInfoList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getHouseInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getHouseInfo(@RequestParam(required = false, value = "id") String id) {
        HouseInfo data = houseInfoService.getHouseInfoById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(HouseInfo record) {
        HouseInfo data = houseInfoService.getHouseInfo(record);
        return new Result(true, data);
    }

    /**
     * 获取详细信息
     *
     * @param record
     * @return
     */
    @RequestMapping(value = "/detail", method = RequestMethod.GET)
    @ResponseBody
    public Result detail(HouseInfo record) {
        HouseInfo data = houseInfoService.getHouseInfoDetail(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, HouseInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<HouseInfo> pp = houseInfoService.getHouseInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(HouseInfo record) {
        boolean num = houseInfoService.createHouseInfo(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateHouseInfo(HouseInfo record) {
        boolean num = houseInfoService.updateHouseInfo(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteHouseInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = houseInfoService.deleteHouseInfo(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }
}

